

<template>
  <div class="content-grid__header">
    <h2 class="back-link-title">Grilles</h2>
    <div class="content-grid__filters">
      <SearchInput v-model="searchValue"/>
    </div>
  </div>
  <Card>
    <DataTable
        :headers="grilleHeader"
        :items="tableGrille"
        :search-value="searchValue"
        @delete="deleteGrille"
        @click="handleRowClick"
    />
  </Card>
</template>

<script setup lang="ts">

import Card from "@/components/layout/Card.vue";
import DataTable from "@/components/layout/DataTable.vue";
import {useI18n} from "vue3-i18n";
import {computed, onMounted, ref} from "vue";
import {useGrilleService} from "@/inversify.config";
import {notifyError, notifySuccess} from "@/notify";
import {Grille} from "@/types/entities/grille";
import SearchInput from "@/components/layout/SearchInput.vue";
const { t } = useI18n();
const allGrilles = ref<Grille[]>([]);
const grilleService = useGrilleService();
const searchValue = ref("");

const tableGrille = computed(() => {
  return allGrilles.value
      .map((x: Grille) => {
        return {
          id: x.id,
          ponderation: x.ponderation,
          titre: x.titre,
          nomCours: x.cours.nomCours,
          actions: {
            delete: true,
          },
        };
      })
      .sort((a: any, b: any) => {
        if (a.name < b.name) {
          return -1;
        }
        if (a.name > b.name) {
          return 1;
        }
        return 0;
      }) as unknown as Grille[];
});

onMounted(async () => {
  await loadAllGrilles();
});

async function loadAllGrilles() {
  let grilles = await grilleService.getAllGrilles();
  if (grilles && grilles.length > 0) allGrilles.value = grilles;
}

async function deleteGrille(grille: Grille) {
  console.log(grille)
  if (grille.id == null) return;
  let confirmation = confirm(t("validation.grille.delete.confirmation"));
  if (!confirmation) return;
  let response = await grilleService.deleteGrille(grille.id);
  if (response.errors.length == 0) {
    allGrilles.value = allGrilles.value.filter((x) => x.id !== grille.id);
    notifySuccess(t("validation.grille.delete.success"));
  } else {
    let errorMessages = response.getErrorMessages(
        "validation.delete.delete.confirmation",
        "validation.delete.delete.errorOccured"
    );
    notifyError(errorMessages[0]);
  }
}

    const handleRowClick = (e: any) => {
        e.target.parentNode.getElementsByTagName('button')[0].click()
    }

const grilleHeader = [
  {
    text: "Titre",
    value: "titre",
    sortable: true,
    width: 300,
  },
  {
    text: "Nom du cours",
    value: "nomCours",
    sortable: true,
    width: 150,
  },
  {
    text: "Pondération",
    value: "ponderation",
    sortable: true,
    width: 150,
  },
  {
    text: "",
    value: "actions",
    width: 75,
  },
];
</script>